/**
 * Peterson Mutual Exclusion for 2 processes
 */

bool turn;
bool flag[2];
byte cnt;

active [2] proctype mutex()
{
    pid i, j;

    i = _pid;
    j = 1 - _pid;

trying:
    flag[i] = true;
    turn = i;
    !(flag[j] && turn == i) ->

critical:
    cnt++; assert(cnt == 1); cnt--;

    flag[i] = false;
    goto trying
}

/**
 * verify the following LTL properties:
 * - mutual exclusion
 * - progress
 * - lockout-freedom
 */
